IMPLEMENTATION MODULE SrvObj;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    **************************************************************
    A.Iakovlev  Ver  1.0  Initial version              January 91
    A.Iakovlev  Ver  2.0  Renaming                     June 93
    **************************************************************
  *)

  TYPE
    OBJECT = POINTER TO ObjectDescriptor;
    ObjectDescriptor =
      RECORD
        next: OBJECT;
      END;

  PROCEDURE Exist(top, obj: OBJECT): BOOLEAN;
    VAR
      s, t: OBJECT;
    BEGIN
      IF (top = NIL) OR (obj = NIL) THEN
        RETURN FALSE;
      ELSIF top = obj THEN
        RETURN TRUE;
      ELSE
        s := top;
        t := s^.next;
        LOOP
          IF t = NIL THEN
            RETURN FALSE;
          ELSIF t = obj THEN
            RETURN TRUE;
          ELSE
            s := t;
            t := s^.next;
          END;
        END;
      END;
    END Exist;

  PROCEDURE Prev(top, obj: OBJECT): OBJECT;
    VAR
      s, t: OBJECT;
    BEGIN
      IF (top = NIL) OR (obj = NIL) THEN
        RETURN NIL;
      ELSIF top = obj THEN
        RETURN obj;
      ELSE
        s := top;
        t := s^.next;
        LOOP
          IF t = NIL THEN
            RETURN NIL;
          ELSIF t = obj THEN
            RETURN s;
          ELSE
            s := t;
            t := s^.next;
          END;
        END;
      END;
    END Prev;

  END SrvObj.
